#pragma once

#include "object.h"

class Crystal;
class Lift;

class Chara : public UQ::Task, public Object{
public:
	enum Status{
		WALK, DASH, BREAK, SIT, JUMP, SWIM,
		LADDER, DAMAGE, DIE,
		DOOR, CLEAR, TITLE,
	};

public:
	Chara(int x, int y, Drct drct);

	void setStatus(Status status);
	Status getStatus(void) const{return status_;}

	void beDamaged(float enemyX);
	void setScreenPos(void);

	void update(void);
	void render(void);
private:
	void holdLadder(void);
	void LeftRight(void);

private:
	Status status_;
public:
	int count_;
	static const int COUNT_PREJUMP_ = 8;
	Crystal* pCarryCrystal_;
	Lift* pRideLift_;
	int dashCount_;
	enum{NOT, TAKE_BACK, FOLLOW_THROUGH} throwTransition_;
	int throwCount_;
	static int yellow_;
	int green_;
	int hp_;
	static int rest_;
	int damageCount_;
	int crystalCount_;
};

// 泡
class Bubble : public UQ::Task, public Object{
public:
	Bubble(Chara* pchara);
	void update(void);
	void render(void);
private:
	int count_;
};