#pragma once

#define _CRT_SECURE_NO_WARNINGS
#include <UQGL.h>
#include <cmath>
#include <cstring>

enum TextureId{
	TEX_LOGO,
	TEX_CHARA, TEX_ENEMY, TEX_MAP, TEX_FONT,
	TEX_GROUND, TEX_UNGRA, TEX_FORT, TEX_WATER
};
static const int TO_TEMPOUP = 10;
enum MusicId{
	MSC_TITLE,
	MSC_GROUND, MSC_WATER, MSC_ATHLE, MSC_SKY, MSC_UNGRA, MSC_FORT,
	MSC_MAP = 100,
	MSC_DIE, MSC_CLEAR, MSC_BOSS, MSC_TEMPOUP, MSC_GAMEOVER
};
enum SoundId{
	SND_JUMP, SND_BREAK, SND_SWIM, SND_DIE, SND_1UP,
	SND_YELLOW, SND_GREEN, SND_BLUE, SND_KILL, SND_EXPLODE, SND_PAUSE,
	SND_PI, SND_PICOON
};

enum UpdatePriority{
	UPDATE_LIFT,
	UPDATE_CHARA,
	UPDATE_ENEMY_EMERGE,
	UPDATE_ENEMY,
	UPDATE_CRYSTAL,
	UPDATE_HIT,
	UPDATE_BUBBLE,
	UPDATE_SCENE,
};

enum DrawPriority{
	RENDER_MAP,
	RENDER_CHARA,
	RENDER_LIFT,
	RENDER_ENEMY,
	RENDER_CRYSTAL,
	RENDER_BUBBLE,
	RENDER_MAPFRONT,
	RENDER_INFO,
	RENDER_SCENE,
	RENDER_FADE,
};

struct GameInfo{
	GameInfo() : world_(0), stage_(0){std::memset(score_, -1, sizeof(score_));}
	bool isTitle(void){return (world_ == 9);}
	bool isStageSelect(void){return (world_ != 9 && stage_ == 0);}

	void setWorldStage(int world, int stage){world_ = world; stage_ = stage;}	
	
	void setScore(int score){score_[world_ - 1][stage_ - 1] = score;}
	int getScore(void){return score_[world_ - 1][stage_ - 1];}
	int getScore(int world, int stage){return score_[world - 1][stage - 1];}

	int world_, stage_;
	int score_[5][5]; // 負で未クリア
};
extern GameInfo gameInfo;

static const int SCREEN_WIDTH = 640, SCREEN_HEIGHT = 480;

template<typename T>
inline bool isBetween(T value, T begin, T end)
{
	if((begin <= value && value <= end) || (end <= value && value <= begin)) return true;
	return false;
}

template<typename T>
inline int sign(T value)
{
	if(value < 0) return -1;
	if(value > 0) return 1;
	return 0;
}

#define ARRAY_SIZE(a) (sizeof(a) / sizeof(a[0]))
