#include "PCH.h"
#include "hit.h"
#include "chara.h"
#include "crystal.h"
#include "enemy.h"

void Hit::update(void)
{
	Chara* pChara = UQ::getTM()->get<Chara>();
	if(pChara->getStatus() == Chara::DOOR || pChara->getStatus() == Chara::DIE) return;

	// Chara <-> Crystal
	for(unsigned int i = 0; i < UQ::getTM()->count<Crystal>(); i++){Crystal* pCrystal = UQ::getTM()->enumerate<Crystal>(i);
		if(pCrystal->getStatus() == Crystal::LIE || pCrystal->getStatus() == Crystal::FALL || pCrystal->getStatus() == Crystal::SET){
			if(pCrystal->hitsRect(pChara->x_ - 5, pChara->y_ - 5, pChara->width_ + 10, pChara->height_ + 10)){
				switch(pCrystal->color_){
				case YELLOW:
					pCrystal->setStatus(Crystal::GOTTEN);
					pChara->yellow_++;
					UQ::getSM()->play(SND_YELLOW);
					if(pChara->yellow_ == 100){
						pChara->rest_++; pChara->yellow_ = 0;
						UQ::getSM()->play(SND_1UP);
					}
					break;
				case GREEN:
					pCrystal->setStatus(Crystal::GOTTEN);
					pChara->green_++;
					UQ::getSM()->play(SND_GREEN);
					if(pChara->green_ == 5){
						pChara->rest_++;
						UQ::getSM()->play(SND_1UP);
					}
					break;
				case BLUE:
					pCrystal->setStatus(Crystal::GOTTEN);
					if(pChara->hp_ < 3) pChara->hp_++;
					UQ::getSM()->play(SND_BLUE);
					break;
				case RED:
					if(UQ::getIM()->isPressed(UQ::InputMgr::VC1_BTN2)){
						if(pChara && !pChara->pCarryCrystal_){
							pChara->pCarryCrystal_ = pCrystal;
							pCrystal->setStatus(Crystal::CARRIED);
						}
					}
					break;
				}
			}
		}
	}

	// Chara <-> Enemy
	for(unsigned int i = 0; i < UQ::getTM()->count<Enemy>(); i++){Enemy* pEnemy = UQ::getTM()->enumerate<Enemy>(i);
		if(pEnemy->canHit() && pEnemy->hitsObject(pChara)){
			if(pEnemy->canBeTroddenOn() && pChara->py_ + pChara->height_ - 3 < pEnemy->py_){
				pChara->setStatus(Chara::JUMP);
				pChara->vy_ = 0;
				pEnemy->beDamaged();
			}else{
				pChara->beDamaged(pEnemy->x_);
			}
		}
	}

	// Enemy <-> Crystal
	for(unsigned int i = 0; i < UQ::getTM()->count<Crystal>(); i++){Crystal* pCrystal = UQ::getTM()->enumerate<Crystal>(i);
		if(pCrystal->getStatus() == Crystal::THROWN || pCrystal->getStatus() == Crystal::CARRIED){
			for(unsigned int j = 0; j < UQ::getTM()->count<Enemy>(); j++){Enemy* pEnemy = UQ::getTM()->enumerate<Enemy>(j);
				if(pEnemy->canHit() && pEnemy->hitsObject(pCrystal)){
					if(pCrystal->getStatus() == Crystal::CARRIED){
						pCrystal->setStatus(Crystal::INVALID);
						pChara->pCarryCrystal_ = 0;
					}
					pEnemy->beDamaged();
				}
			}
		}
	}
}