#include "PCH.h"
#include "lift.h"
#include "map.h"

Lift::Lift(int x, int y, Type type, int value) :
	UQ::Task(UPDATE_LIFT, RENDER_LIFT),
	Object(x * 32.f, y * 32.f, 32, 32, LEFT),
	type_(type),
	value_(value),
	count_(0)
{
}

void Lift::update(void)
{
	count_++;
	px_ = x_; py_ = y_;
	switch(type_){
	case LR:
		vx_ = cos(count_ / 60.f) * 2; // 4マス動く
		x_ += vx_;
	break;
	case UD:
		vy_ = cos(count_ / 60.f) * 2;
		y_ += vy_;
	break;
	}
}

void Lift::render(void)
{
	UQ::getGM()->setTexture(TEX_MAP);
	UQ::Polygon rect;
	rect.setRectangle(x_ - pMap_->left_, y_ - pMap_->top_, 32, 32);
	rect.setRectangleTexture((value_ % 16) * 32, (value_ / 16) * 32, 32, 32);
	UQ::getGM()->drawPolygon(rect);
}