#include "PCH.h"
#include "map.h"
#include "scene.h"
#include "chara.h"
#include "enemy.h"
#include "crystal.h"
#include "lift.h"
#include "hit.h"

const Map::Kind Map::kind_[256] = {
	PNFL, PNFL, PNFL, PNFL, PNFL, PNFL, PNFL, PNFL, PNFL, PNFL, PNFL, PNFL, EMPT, EMPT, EMPT, EMPT,
	PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, EMPT, EMPT, EMPT, EMPT,
	PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, PNTH, EMPT, EMPT, EMPT, EMPT,
	GRBL, GRBL, GRBL, GRBL, GRBL, GRBL, BLCK, BLCK, BLCK, BLCK, BLCK, BLCK, EMPT, EMPT, EMPT, EMPT,
	GRBL, GRBL, GRBL, GRBL, GRBL, GRBL, BLCK, BLCK, BLCK, BLCK, BLCK, BLCK, EMPT, EMPT, EMPT, EMPT,
	GRBL, GRBL, GRBL, GRBL, GRBL, GRBL, BLCK, BLCK, BLCK, BLCK, BLCK, BLCK, EMPT, EMPT, EMPT, EMPT,
	GRBL, GRBL, EMPT, GRBL, GRBL, EMPT, BLCK, BLCK, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	GRBL, GRBL, THRU, GRBL, GRBL, THRU, BLCK, BLCK, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	GRTH, GRTH, GRTH, GRTH, GRTH, GRTH, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	GRTH, GRTH, GRTH, GRTH, GRTH, GRTH, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	GRTH, GRTH, GRTH, GRTH, GRTH, GRTH, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	BLCK, BLCK, BLCK, WATR, WATR, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	LADR, EMPT, EMPT, EMPT, FLOR, FLOR, FLOR, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	THRU, DST1, DST2, DST3, DST4, DST5, DGOL, DPRV, DNXT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT,
	DOOR, DOOR, DOOR, DOOR, DOOR, DOOR, DOOR, DOOR, DOOR, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT, EMPT
};

const Map::Status Map::status_[KIND_MAX] = {
	{false, true }, // EMPT
	{true,  false}, // BLCK
	{true,  true }, // FLOR
	{false, true }, // THRU
	{false, true }, // LADR
	{true,  true }, // PNFL
	{false, true }, // PNTH
	{true,  false}, // GRBL
	{false, true }, // GRTH
	{false, true }, // DOOR
	{false, true }, // DST1
	{false, true }, // DST2
	{false, true }, // DST3
	{false, true }, // DST4
	{false, true }, // DST5
	{false, true }, // DGOL
	{false, true }, // DPRV
	{false, true }, // DNXT
	{false, true }, // WATR
	{true , false}, // ICEB
};

//============================================================================
Map::Map(int door) : UQ::Task(NOT_INSERT_, RENDER_MAP), crystalCount_(0), bg_(0), left_(0), top_(0)
{
	Object::setMap(this);
	WCHAR fileName[20];
	wsprintf(fileName, L"map\\%d%d.fmf", gameInfo.world_, gameInfo.stage_);
	fmfMap_.Open(fileName);

	static const Color COLOR[5] = {GRAY, RED, BLUE, YELLOW, GREEN};
	static const Object::Drct DRCT[3] = {Object::LEFT, Object::RIGHT};
	static const EnemyEmerge::Kind KIND[8] = {EnemyEmerge::WING1, EnemyEmerge::TORPEDO1, EnemyEmerge::TIRE, EnemyEmerge::SAW, EnemyEmerge::SAW,EnemyEmerge::SAW,EnemyEmerge::SAW, EnemyEmerge::BOSS1};
	static const Lift::Type TYPE[2] = {Lift::LR, Lift::UD};

	int dataLayer = getLayerCount() - 1;
	int hideLayer = getLayerCount() - 2;
	int bgm = 0;
	int x = 0, y = 0, count = 0;
	for(int i = 0; i < getWidth(); i++){for(int j = 0; j < getHeight(); j++){
		int value = getValue(dataLayer, i, j);
		if(door == EMPT && (value == CHARA_L || value == CHARA_R)){
			Chara* pChara = new Chara(i, j, DRCT[value]);
			if(gameInfo.isTitle()) pChara->setStatus(Chara::TITLE);
			UQ::getTM()->insert(pChara, this);
		}else if(isBetween<int>(value - BGM_GROUND, 0, 5)){
			if(bgm == 0) bgm = value - BGM_GROUND + MSC_GROUND;
		}else if(isBetween<int>(value - BG_GROUND, 0, 3)){
			if(bg_ == 0) bg_ = value - BG_GROUND + TEX_GROUND;
		}else if(isBetween<int>(value, ENEMY, BOSS + 4)){ 
			UQ::getTM()->insert(new EnemyEmerge(i, j, KIND[value / 16 - 4], COLOR[(value % 16) % 5], DRCT[(value % 16) / 5]), this);
			if(value < BOSS) crystalCount_++;
		}else if(isBetween<int>(value - CRYSTAL, 0, 4)){
			UQ::getTM()->insert(new Crystal(COLOR[value % 16], i, j), this);
			crystalCount_++;
		}else if(value == LIFT_LR || value == LIFT_UD){
			int liftValue = 0;
			for(int k = 0; k < getLayerCount() - 1; k++){
				if(kind_[getValue(k, i, j)] != EMPT) liftValue = getValue(k, i, j);
			}
			UQ::getTM()->insert(new Lift(i, j, TYPE[value % 16], liftValue), this);
			for(int k = 0; k < getLayerCount() - 1; k++){setValue(k, i, j, 255);}
		}else if(isBetween<int>(value, HIDE1, HIDE5)){
			if(gameInfo.score_[gameInfo.world_ - 1][value - HIDE1] >= 0) setValue(hideLayer, i, j, 255);
		}

		if(door != EMPT && door == getKind(i, j)){
			UQ::getTM()->insert(new Chara(i, j + 1, Object::RIGHT), this);
			int idxBgm = getValue(dataLayer, i - 1, j) - BGM_GROUND;
			if(isBetween<int>(idxBgm, 0, 5)) bgm = idxBgm + MSC_GROUND;
			int idxBg = getValue(dataLayer, i + 1, j) - BG_GROUND;
			if(isBetween<int>(idxBg, 0, 2)) bg_ = idxBg + TEX_GROUND;
		}
	}}
	UQ::getTM()->insert(new MapFront(this), this);

	if(gameInfo.isStageSelect()){
		bgm = MSC_MAP;
	}else{
		if(!gameInfo.isTitle()) UQ::getTM()->insert(new Timer(bgm), this);
	}
	if(!gameInfo.isTitle()){
		UQ::getTM()->insert(new Hit(), this);
		UQ::getTM()->insert(new Info(), this);
		UQ::getMM()->play(bgm, true);
	}

	UQ::getTM()->insert(new Fade(false));
}
UQ::Vector2DTemplate<int> Map::enterDoor(int door){
	UQ::Vector2DTemplate<int> charaNewPos(0, 0);
	int dataLayer = getLayerCount() - 1;
	int bgm = 0, bg = 0;
	for(int i = 0; i < getWidth(); i++){for(int j = 0; j < getHeight(); j++){
		static const Data DOOR_KIND[4] = {A2, A1, B2, B1};
		int value = getValue(dataLayer, i, j);
		if(isBetween<int>(value - BGM_GROUND, 0, 5)){
			if(bgm == 0) bgm = value - BGM_GROUND + MSC_GROUND;
		}else if(isBetween<int>(value - BG_GROUND, 0, 2)){
			if(bg == 0) bg = value - BG_GROUND + TEX_GROUND;
		}else if(value == DOOR_KIND[door - A1]){
			charaNewPos.set(i, j);
			if(getValue(dataLayer, i - 1, j) != 255) bgm = getValue(dataLayer, i - 1, j) - BGM_GROUND + MSC_GROUND;
			if(getValue(dataLayer, i + 1, j) != 255) bg = getValue(dataLayer, i + 1, j) - BG_GROUND + TEX_GROUND;
		}
	}}
	UQ::getTM()->get<Timer>()->setBgm(bgm);
	bg_ = bg;
	UQ::getTM()->insert(new Fade(false));
	return charaNewPos;
}
Map::Kind Map::getKind(int x, int y)
{
	if(x < 0 || x >= getWidth()) return BLCK;
	if(y < 0 || y >= getHeight()) return EMPT;
	Kind ret = EMPT;
	for(int i = 0; i < getLayerCount() - 1; i++){
		Kind kind = kind_[getValue(i, x, y)];
		if(kind != EMPT && kind != WATR) ret = kind;
	}
	return ret;
}
bool Map::isWater(int x, int y)
{
	if(x < 0 || x >= getWidth()) return false;
	if(y < 0 || y >= getHeight()) return false;
	for(int i = 0; i < getLayerCount() - 1; i++){
		if(kind_[getValue(i, x, y)] == WATR) return true;
	}
	return false;
}
void Map::render(void)
{
	UQ::Polygon rect;

	UQ::getGM()->setTexture(bg_);
	int wid = UQ::getGM()->getTextureWidth(bg_), hei = UQ::getGM()->getTextureHeight(bg_);
	for(int i = 0; i <= SCREEN_WIDTH / wid + 1; i++){for(int j = 0; j <= SCREEN_HEIGHT / hei + 2; j++){
		int y = (getHeight() * 32 - SCREEN_HEIGHT) / 2 + SCREEN_HEIGHT - hei + 10;
		rect.setRectangle(i * wid - fmod(left_ / 2, (float)wid), y - j * hei - fmod(top_ / 2, (float)hei), wid, hei);
		rect.setRectangleTexture(0, 0, wid, hei);
		UQ::getGM()->drawPolygon(rect);
		//if(y > 0){
		//}
	}}

	UQ::getGM()->setTexture(TEX_MAP);
	for(int k = 0; k < getLayerCount() - 1; k++){
		for(int i = (int)left_ / 32; i <= ((int)left_ + SCREEN_WIDTH) / 32; i++){for(int j = (int)top_ / 32; j <= ((int)top_ + SCREEN_HEIGHT) / 32; j++){
			int value = getValue(k, i, j);
			if(kind_[value] != EMPT && kind_[value] != WATR){
				rect.setRectangle(i * 32 - left_, j * 32 - top_, 32, 32);
				rect.setRectangleTexture((value % 16) * 32, (value / 16) * 32, 32, 32);
				UQ::getGM()->drawPolygon(rect);
			}
		}}
	}

	static const int SHADOW_WIDTH = 7;
	UQ::getGM()->unsetTexture();
	UQ::Polygon shadow;
	shadow.setColor(0x55000000);
	for(int i = (int)left_ / 32; i <= ((int)left_ + SCREEN_WIDTH) / 32; i++){for(int j = (int)top_ / 32; j <= ((int)top_ + SCREEN_HEIGHT) / 32; j++){
		if(kind_[getValue(0, i, j)] == GRTH && getStatus(i, j).Thru){
			if(getKind(i, j - 1) == GRBL){
				shadow.setRectangle(i * 32 - left_, j * 32 - top_, 32 - ((getKind(i + 1, j) != GRBL && kind_[getValue(0, i + 1, j)] != GRTH) ? 3 : 0), SHADOW_WIDTH);
				if(getKind(i - 1, j - 1) != GRBL){
					shadow.vertex_[0].vector_.x_ += 3.f;
					shadow.vertex_[2].vector_.x_ += SHADOW_WIDTH;
				}
				UQ::getGM()->drawPolygon(shadow);
			}
			if(getKind(i - 1, j) == GRBL){
				shadow.setRectangle(i * 32 - left_, j * 32 - top_ + ((getKind(i, j - 1) == GRBL) ? SHADOW_WIDTH : 0),
					SHADOW_WIDTH, 32 - ((getKind(i, j + 1) != GRBL && kind_[getValue(0, i, j + 1)] != GRTH) ? 3 : 0) - ((getKind(i, j - 1) == GRBL) ? SHADOW_WIDTH : 0));
				if(getKind(i - 1, j - 1) != GRBL){
					shadow.vertex_[0].vector_.y_ += 3.f;
					shadow.vertex_[1].vector_.y_ += SHADOW_WIDTH;
				}
				UQ::getGM()->drawPolygon(shadow);
			}
			if(getKind(i, j - 1) != GRBL && getKind(i - 1, j) != GRBL && getKind(i - 1, j - 1) == GRBL){
				shadow.setRectangle(i * 32 - left_, j * 32 - top_, SHADOW_WIDTH, SHADOW_WIDTH);
				UQ::getGM()->drawPolygon(shadow);
			}
		}
	}}
}

//============================================================================
void MapFront::render(void)
{
	UQ::getGM()->setTexture(TEX_MAP);
	UQ::Polygon rect;

	rect.setColor(0x40FFFFFF);
	for(int k = 0; k < pMap_->getLayerCount() - 1; k++){
		for(int i = (int)pMap_->left_ / 32; i <= ((int)pMap_->left_ + SCREEN_WIDTH) / 32; i++){
		for(int j = (int)pMap_->top_ / 32; j <= ((int)pMap_->top_ + SCREEN_HEIGHT) / 32; j++){
			int value = pMap_->getValue(k, i, j);
			if(pMap_->kind_[value] == Map::WATR){
				rect.setRectangle(i * 32 - pMap_->left_, j * 32 - pMap_->top_, 32, 32);
				rect.setRectangleTexture((value % 16) * 32, (value / 16) * 32, 32, 32);
				UQ::getGM()->drawPolygon(rect);
			}
		}}
	}
}
