#include "PCH.h"
#include "object.h"
#include "map.h"

const float Object::G_ = 0.25f;
Map* Object::pMap_ = 0;

bool Object::hitsObject(Object *pObject)
{
	if(hitsRect(pObject->x_, pObject->y_, pObject->width_, pObject->height_)){
		return true;
	}
	return false;
}

bool Object::hitsRect(float x, float y, int width, int height)
{
	if(x_ + width_ - 1 >= x && x_ <= x + width - 1 && y_ <= y + height - 1 && y_ + height_ - 1 >= y){
		return true;
	}
	return false;
}

bool Object::hitsMapLeft(void)
{
	bool ret = false;
	for(int i = 0; i <= (height_ - 1) / 32; i++){
		ret |= !pMap_->getStatus(x_, y_ + i * 32).Thru;
	}
	ret |= !pMap_->getStatus(x_, y_ + height_ - 1).Thru;
	return ret;
}

bool Object::hitsMapRight(void)
{
	bool ret = false;
	for(int i = 0; i <= (height_ - 1) / 32; i++){
		ret |= !pMap_->getStatus(x_ + width_ - 1 + 0.99f, y_ + i * 32).Thru;
	}
	ret |= !pMap_->getStatus(x_ + width_ - 1 + 0.99f, y_ + height_ - 1).Thru;
	return ret;
}

bool Object::hitsMapUp(void)
{
	bool ret = false;
	for(int i = 0; i <= (width_ - 1) / 32; i++){
		ret |= !pMap_->getStatus(x_ + i * 32, y_).Thru;
	}
	ret |= !pMap_->getStatus(x_ + width_ - 1, y_).Thru;
	return ret;
}

bool Object::hitsMapDown(void)
{
	bool ret = false;
	for(int i = 0; i <= (width_ - 1) / 32; i++){
		ret |= pMap_->getStatus(x_ + i * 32, y_ + height_ - 1 + 0.99f).On;
	}
	ret |= pMap_->getStatus(x_ + width_ - 1, y_ + height_ - 1 + 0.99f).On;
	ret &= floor((py_ + height_ - 1) / 32) < floor((y_  + height_ - 1) / 32);
	return ret;
}

bool Object::isFall(void)
{
	bool ret = true;
	for(int i = 0; i <= (width_ - 1) / 32; i++){
		ret &= !pMap_->getStatus(x_ + i * 32, y_ + height_).On;
	}
	ret &= !pMap_->getStatus(x_ + width_ - 1, y_ + height_).On;
	return ret;
}

void Object::correctLeft(bool zeroV)
{
	x_ = (floor(x_ / 32) + 1) * 32;
	if(zeroV) vx_ = 0.f;
}

void Object::correctRight(bool zeroV)
{
	x_ = (floor((x_ + width_ - 1 + 0.99f) / 32)) * 32 - width_;
	if(zeroV) vx_ = 0.f;
}

void Object::correctUp(bool zeroV)
{
	y_ = (floor(y_ / 32) + 1) * 32;
	if(zeroV) vy_ = 0.f;
}

void Object::correctDown(bool zeroV)
{
	y_ = (floor((y_ + height_ - 1 + 0.99f) / 32)) * 32 - height_;
	if(zeroV) vy_ = 0.f;
}
