#pragma once

enum Color {GRAY = 0, RED, BLUE, YELLOW, GREEN};

class Map;

class Object{
public:
	enum Drct{LEFT = 0, RIGHT, UP, DOWN};

public:
	Object(float x, float y, int width, int height, Drct drct) :
	  x_(x), y_(y),
	  px_(x), py_(y),
	  vx_(0), vy_(0),
	  width_(width), height_(height),
	  drct_(drct)
	{}
	virtual ~Object(){}

public:
	static void setMap(Map* pMap){pMap_ = pMap;}
	bool hitsObject(Object* pObject);
	bool hitsRect(float x, float y, int width, int height);

	bool hitsMapLeft(void);
	bool hitsMapRight(void);
	bool hitsMapUp(void);
	bool hitsMapDown(void);
	bool isFall(void);

	void correctLeft(bool zeroV);
	void correctRight(bool zeroV);
	void correctUp(bool zeroV);
	void correctDown(bool zeroV);

public:
	static const float G_;
	static const int SCREEN_EXPANSION_ = 32 * 10;
	float x_, y_;
	float px_, py_; // 1フレーム前の座標
	float vx_, vy_; // 速度
	int width_, height_;
	Drct drct_;
	static Map* pMap_;
};

inline bool hits(float x1, float y1, int width1, int height1, float x2, float y2, int width2, int height2)
{
	if(x1 + width1 - 1 >= x2 && x1 <= x2 + width2 - 1 && y1 <= y2 + height2 - 1 && y1 + height1 - 1 >= y2){
		return true;
	}
	return false;
}