#pragma once

// メニュー
class Menu : public UQ::Task{
public:
	struct Item{
		char* string;
		bool isValid;
		bool fades;
	};
public:
	Menu(int itemCount, Item item[], int top, bool isBackDark);
	void update(void);
	void render(void);
	int getCursorY(void) const{return cursorY_;}
	bool isEnd(void) const{return isEnd_;}
private:
	bool isEnd_;
	bool isSelecting_;
	int cursorY_;
	int top_;
	bool isBackDark_;
	Item item_[5];
	int itemCount_;
};

// タイトル
class Title : public UQ::Task{
public:
	Title();
	void update(void);
	void render(void);
};

// タイマー
class Timer : public UQ::Task{
public:
	Timer(int bgm) : UQ::Task(UPDATE_SCENE), count_(0), bgm_(bgm){}
	void setBgm(int bgm);
	int getRestTime(void) const{return (COUNT_MAX_ - count_ + 60 - 1) / 60;}
	void update(void);
private:
	static const int COUNT_MAX_ = 300 * 60;
	int count_;
	int bgm_;
};

// 情報
class Info : public UQ::Task{
public:
	Info() : UQ::Task(NOT_INSERT_, RENDER_INFO){}
	void render(void);
};

// ステージスタート（"STAGE N START!"）
class StageStart : public UQ::Task{
public:
	StageStart() : UQ::Task(NOT_INSERT_, RENDER_SCENE), count_(0){}
	void render(void);
private:
	int count_;
};

// ステージクリア
class StageClear : public UQ::Task{
public:
	StageClear(int mapCrystal, int charaCrystal);
	void render(void);
private:
	int count_;
	int mapCrystal_, charaCrystal_;
	int score_;
};

// ゲームオーバー
class GameOver : public UQ::Task{
public:
	GameOver();
	void render(void);
private:
	int count_;
};

// ポーズ
class Pause : public UQ::Task{
public:
	Pause();
	void update(void);
	void render(void);
};

// フェード
class Fade : public UQ::Task{
public:
	Fade(bool isFadeOut);
	void render(void);
	bool isEnd(void) const{return (count_ >= COUNT_MAX_ - 1);}
private:
	static const int COUNT_MAX_ = 30;
	int count_;
	bool isFadeOut_;
};